require "spec_helper"

describe Bindep do
  it "exposes a singleton context instance" do
    context = Bindep.context

    expect(context).to be_a Bindep::Context
    expect(Bindep.context).to eq context
  end

  it "evaluates a Bindepfile" do
    file = Tempfile.new('Bindep')
    file.write "check 'test1'\ncheck 'test2'"
    file.close

    context = Bindep.context

    expect(context).to receive(:check).with("test1")
    expect(context).to receive(:check).with("test2")

    Bindep.load_file file.path

    file.unlink
  end

  it "sends all method calls to the singleton context instance" do
    context = Bindep.context

    expect(context).to receive(:define) do |arg, &blk| 
      expect(blk.call).to eq :blocktest
      expect(arg).to eq :test1
    end

    Bindep.define(:test1) { :blocktest }
  end  
end
