require 'spec_helper'

describe Bindep::Helpers do
  context '.cmd_interactive' do 
    it 'works on success' do
      expect(Bindep::Helpers.cmd_interactive 'true').to eq 0
    end

    it 'works on failure' do
      expect(Bindep::Helpers.cmd_interactive 'false', false).to eq 1
    end

    it 'raises on failure' do
      expect do
        Bindep::Helpers.cmd_interactive 'false'
      end.to raise_error RuntimeError, "Command 'false' returned status 1"
    end
  end

  context '.cmd' do
    it 'works on success' do
      stdout, stderr, status = Bindep::Helpers.cmd 'cat', 'test'

      expect(stdout).to eq 'test'
      expect(stderr).to eq ''
      expect(status).to eq 0
    end

    it 'works on failure' do
      stdout, stderr, status = Bindep::Helpers.cmd 'false', nil, false
      expect(status).to eq 1
    end

    it 'fails on failure' do
      expect do
        Bindep::Helpers.cmd 'false'
      end.to raise_error RuntimeError, "Command 'false' returned status 1"
    end
  end
  
  it 'has .command_exists?' do
    expect(Bindep::Helpers.command_exists? 'cat').to eq true
    expect(Bindep::Helpers.command_exists? 'does_not_exists').to eq false
  end

  it 'has working which_test' do
    expect(Bindep::Helpers.which_test).to eq true
  end
end

